/****************************************************************

		Le compte en banque vu par Java


*******************************************************************  
			J. Ferber - 1999
*****************************************************************/

/* la classe Personne */
public class Personne 
{

	String nom;
	String prenom;
	
	void impCoord()
	{
		System.out.println("Nom:"+nom+", "+prenom);
	}
	
	Personne(String n, String p) 
	{
		nom = n;
		prenom = p;
	}
}


/* la classe Compte */

class Compte {

	static long compteurNumero=100; // on demarre les comptes a partir de 100
		
	long solde;
	long numero;
	Personne proprietaire;

		/* constructeurs */
	Compte(long s, Personne prop) {
		solde = s;
		numero = compteurNumero++;
		proprietaire = prop;
	}
		
	/* acces */
	long avoirSolde(){return(solde);}
	long avoirNumero(){return(numero);}

	void deposer(long s){
		solde=solde +s;
	}

	void retirer(long s){
		solde=solde-s;
	}
	
	boolean retirerTest(long s)
	{
		if ((solde - s) >= 0) 
		{
			retirer(s);
			return(true);
		}
		else
			return(false);
		}

	void afficher()
	{
		System.out.println("Compte: " + numero + ", solde: " + solde);
	}

	void virer(long s, Compte vers)
	{
		if (retirerTest(s))
			vers.deposer(s);
		else
			System.out.println("Erreur, impossible de retirer "+s+" du compte "+numero);
	}

	void impSolde()
	{
		proprietaire.impCoord();
		System.out.println("votre compte " + numero + " a un solde de " + solde);
	}
}

/* la classe CompteCredit */

class CompteCredit extends Compte {
	float tauxRemuneration; 

	CompteCredit(long s, Personne prop, float taux) {
		super(s,prop);
		proprietaire = prop;
		solde = s;
		tauxRemuneration = taux;
	}

	void calculInterets()
	{
		solde = (long) (solde + (solde * tauxRemuneration));
	}
}

/* la classe ComptePayant */
class ComptePayant extends Compte {

	ComptePayant(long s, Personne prop) {
			super(s,prop);
	}

	void retirer(long s){
		solde = solde - s - 5;
	}
}

